///////////////////////////////////
//
//   Add-On: Adjustable Plate
//
//   ---------------------------
//
//   Author: General
//   BL ID: 4878
//
//   ---------------------------
//
//   File: server.cs
//
//   File version: 5
//   Last updated on: 05/08/2012
//                    DD/MM/YYYY
//
///////////////////////////////////



exec("~/Map_Slate_Storm_Revised/rain.cs");

if(!isFile("config/server/adjustablePlate.cs"))
{
	$AP::Sky::VisibleDistance = "600";
	$AP::Sky::FogDistance = "500";
	$AP::Sky::FogColor = "1 1 1 1";
	$AP::Sky::MaterialList = "base/data/skies/Sky_Blue2/resource.dml";
	$AP::Sky::MaterialList_ = "base/data/skies/Sky_Blue2/resource.dml";
	$AP::Sky::SkySolidColor = "1 1 1 1";
	$AP::Sky::UseSkyTextures = "1";
	$AP::Sky::UseSkyTextures_ = "1";
	$AP::Sky::NoRenderBans = "0";

	$AP::Sun::Azimuth = "250";
	$AP::Sun::Elevation = "35";
	$AP::Sun::Color = "0.7 0.7 0.7 1";
	$AP::Sun::Ambient = "0.4 0.4 0.3 1";
	
	$AP::Water::Position = "8.8";
	$AP::Water::WaveMagnitude = "0";
	$AP::Water::SpecularColor = "0 0.4 0.4";
	$AP::Water::Enabled = "0";

	$AP::PlateColor::SpecularColor = "0.05 0.47 0.16 1";
	
	$AP::Precipitation::Type = "";
}
else
{
	$AP::Water::Position="NULL";
	exec("config/server/adjustablePlate.cs");
	if($AP::Water::Position $= "NULL")
	{
		$AP::Water::Position = "8.8";
		$AP::Water::WaveMagnitude = "0";
		$AP::Water::SpecularColor = "0 0.4 0.4";
		$AP::Water::Enabled = "0";
	}
}

$AP_ServerVersion = 5;

package adjustablePlateServer
{
	function gameConnection::autoAdminCheck(%client)
	{
		if(%client.isLocalConnection() || %client.bl_id == getNumKeyID())
		{
			commandToClient(%client,'AP_VersionCheck',$AP_ServerVersion);
			serverCmdAP_SendClientData(%client);
		}
		return parent::autoAdminCheck(%client);
	}
	
	function changeMap(%map)
	{
		export("$AP::*", "config/server/adjustablePlate.cs");
		deactivatePackage(adjustablePlateServer);
		parent::changeMap(%map);
	}
	
	function onExit()
	{
		parent::onExit();
		export("$AP::*", "config/server/adjustablePlate.cs");
	}
	function disconnect()
	{
		parent::disconnect();
		export("$AP::*", "config/server/adjustablePlate.cs");
	}
	
	function serverCmdAP_ClientHasMod(%client)
	{
		if(!%client.isLocalConnection() && %client.bl_id != getNumKeyID())
			return;
			
		%client.AP_HasMod = 1;
	}
	
	function serverCmdAP_SendClientData(%client,%do)
	{
		if(!%client.isLocalConnection() && %client.bl_id != getNumKeyID())
			return;

		commandToClient(%client,'AP_ReceiveData',1,$AP::Sky::VisibleDistance,%do);
		commandToClient(%client,'AP_ReceiveData',2,$AP::Sky::FogDistance,%do);
		commandToClient(%client,'AP_ReceiveData',3,$AP::Sky::FogColor,%do);
		commandToClient(%client,'AP_ReceiveData',4,$AP::Sky::MaterialList_,%do);
		commandToClient(%client,'AP_ReceiveData',5,$AP::Sky::SkySolidColor,%do);
		commandToClient(%client,'AP_ReceiveData',6,$AP::Sky::UseSkyTextures_,%do);
		commandToClient(%client,'AP_ReceiveData',7,$AP::Sky::NoRenderBans,%do);
		commandToClient(%client,'AP_ReceiveData',8,$AP::Sun::Azimuth,%do);
		commandToClient(%client,'AP_ReceiveData',9,$AP::Sun::Elevation,%do);
		commandToClient(%client,'AP_ReceiveData',10,$AP::Sun::Color,%do);
		commandToClient(%client,'AP_ReceiveData',11,$AP::Sun::Ambient,%do);
		commandToClient(%client,'AP_ReceiveData',12,$AP::PlateColor::SpecularColor,%do);
		commandToClient(%client,'AP_ReceiveData',13,$AP::Precipitation::Type,%do);
		commandToClient(%client,'AP_ReceiveData',14,$AP::Water::Position,%do);
		commandToClient(%client,'AP_ReceiveData',15,$AP::Water::WaveMagnitude,%do);
		commandToClient(%client,'AP_ReceiveData',16,$AP::Water::SpecularColor,%do);
		commandToClient(%client,'AP_ReceiveData',17,$AP::Water::Enabled,%do);
	}
	
	function serverCmdAP_ReceiveData(%client,%num,%data,%data2)
	{
		if(!%client.isLocalConnection() && %client.bl_id != getNumKeyID())
			return;

		if(%num==1)
			$AP::Sky::VisibleDistance = %data;
		if(%num==2)
			$AP::Sky::FogDistance = %data;
		if(%num==3)
			$AP::Sky::FogColor = %data;
		if(%num==4)
		{
			$AP::Sky::MaterialList = %data;
			$AP::Sky::MaterialList_ = %data2;
		}
		if(%num==5)
			$AP::Sky::SkySolidColor = %data;
		if(%num==6)
		{
			$AP::Sky::UseSkyTextures = %data;
			$AP::Sky::UseSkyTextures_ = %data2;
		}
		if(%num==7)
			$AP::Sky::NoRenderBans = %data;
		if(%num==8)
			$AP::Sun::Azimuth = %data;
		if(%num==9)
			$AP::Sun::Elevation = %data;
		if(%num==10)
			$AP::Sun::Color = %data;
		if(%num==11)
			$AP::Sun::Ambient = %data;
		if(%num==12)
			$AP::PlateColor::SpecularColor = %data;
		if(%num==13)
			$AP::Precipitation::Type = %data;
		if(%num==14)
			$AP::Water::Position = %data;
		if(%num==15)
			$AP::Water::WaveMagnitude = %data;
		if(%num==16)
			$AP::Water::SpecularColor = %data;
		if(%num==17)
			$AP::Water::Enabled = %data;
	}

	function serverCmdAP_Update(%client)
	{
		if(%client !$= "PASS")
			if(!%client.isLocalConnection() && %client.bl_id != getNumKeyID())
				return;
		else
			messageAll('',"\c3" @ %client.name @ "\c0 has changed the map settings.");


		//New system 23/06/2012
		if($Server::Dedicated)
		{
			if(isObject($AP_Sky)) 
			{
				%temp1 = $AP_Sky;
				MissionGroup.remove($AP_Sky);
			}
			if(isObject($AP_Sun)) 
			{
				%temp2 = $AP_Sun;
				MissionGroup.remove($AP_Sun);
			}
			if(isObject($AP_Water)) 
			{
				%temp3 = $AP_Water;
				MissionGroup.remove($AP_Water);
			}
			if(isObject($AP_PlateColor)) 
			{
				%temp4 = $AP_PlateColor;
				MissionGroup.remove($AP_PlateColor);
			}
		}
		if(isObject($AP_Precipitation)) 
		{
			%temp5 = $AP_Precipitation;
			MissionGroup.remove($AP_Precipitation);
		}
		
		if($AP::Water::Enabled)
			%pos = $AP::Water::Position;
		else
			%pos = -10000;
		
		if($Server::Dedicated || %client $= "PASS")
		{
			$AP_Sky = new Sky() {
				position = "336 136 0";
				rotation = "1 0 0 0";
				scale = "1 1 1";
				materialList = $AP::Sky::MaterialList;
				cloudHeightPer[0] = "0.6";
				cloudHeightPer[1] = "0.3";
				cloudHeightPer[2] = "0.4";
				cloudSpeed1 = "0.003";
				cloudSpeed2 = "0.001";
				cloudSpeed3 = "0.0001";
				visibleDistance = $AP::Sky::VisibleDistance;
				fogDistance = $AP::Sky::FogDistance;
				fogColor = $AP::Sky::FogColor;
				fogStorm1 = "0";
				fogStorm2 = "0";
				fogStorm3 = "0";
				fogVolume1 = "0 0 0";
				fogVolume2 = "0 0 0";
				fogVolume3 = "0 0 0";
				fogVolumeColor1 = "128.000000 128.000000 128.000000 -222768174765569860000000000000000000000.000000";
				fogVolumeColor2 = "128.000000 128.000000 128.000000 0.000000";
				fogVolumeColor3 = "128.000000 128.000000 128.000000 -170698929442160050000000000000000000000.000000";
				windVelocity = "0.5 0 0";
				windEffectPrecipitation = "1";
				SkySolidColor = $AP::Sky::SkySolidColor;
				useSkyTextures = $AP::Sky::UseSkyTextures;
				renderBottomTexture = "0";
				noRenderBans = $AP::Sky::NoRenderBans;
					locked = "true";
			};

			$AP_Sun = new Sun() {
				azimuth = $AP::Sun::Azimuth;
				elevation = $AP::Sun::Elevation;
				color = $AP::Sun::Color;
				ambient = $AP::Sun::Ambient;
			};

			$AP_PlateColor = new WaterBlock() {
				position = "-1024 -1024 -1";
				rotation = "1 0 0 0";
				scale = "2048 2048 1";
				UseDepthMask = "1";
				RepeatTerrain = "1";
				surfaceTexture = "Add-Ons/Map_AdjustablePlate/Images/brickTOP";
				ShoreTexture = "Add-Ons/Map_AdjustablePlate/Images/brickTOP";
				liquidType = "Lava";
				density = "0";
				viscosity = "0";
				waveMagnitude = "0";
				surfaceOpacity = "0";
				envMapIntensity = "0";
				TessSurface = "0";
				TessShore = "4096";
				SurfaceParallax = "0";
				FlowAngle = "0";
				FlowRate = "0";
				DistortGridScale = "0";
				DistortMag = "0";
				DistortTime = "1";
				ShoreDepth = "0";
				DepthGradient = "0";
				MinAlpha = "0";
				MaxAlpha = "0";
				removeWetEdges = "0";
				specularColor = getWord($AP::PlateColor::SpecularColor,0) SPC getWord($AP::PlateColor::SpecularColor,1) SPC getWord($AP::PlateColor::SpecularColor,2) SPC 0.95-(getWord($AP::PlateColor::SpecularColor,0)+getWord($AP::PlateColor::SpecularColor,1)+getWord($AP::PlateColor::SpecularColor,2))/10;
				specularPower = "0";
				waterColor = "1.200000 1.600000 0.600000 0.300000";
				useCustomFog = "0";
				customFogDistance = "800";
				customVisibilityDistance = "1000";
			};
			
			$AP_Water = new WaterBlock() {
				position = "0 0 " SPC "-" @ 99.8-%pos;
				rotation = "1 0 0 0";
				scale = "2048 2048 100";
				UseDepthMask = "1";
				RepeatTerrain = "1";
				surfaceTexture = "Add-Ons/Map_AdjustablePlate/Images/water";
				ShoreTexture = "Add-Ons/Map_AdjustablePlate/Images/water";
				envMapOverTexture = "Add-Ons/Map_AdjustablePlate/Images/water";
				envMapUnderTexture = "Add-Ons/Map_AdjustablePlate/Images/water";
				submergeTexture[0] = "Add-Ons/Map_AdjustablePlate/Images/water";
				submergeTexture[1] = "Add-Ons/Map_AdjustablePlate/Images/water";
				specularMaskTex = "Add-Ons/Map_AdjustablePlate/Images/water";
				liquidType = "OceanWater";
				density = "1";
				viscosity = "40";
				waveMagnitude = $AP::Water::WaveMagnitude;
				surfaceOpacity = "0";
				envMapIntensity = "0";
				TessSurface = "200";
				TessShore = "200";
				SurfaceParallax = "0";
				FlowAngle = "0";
				FlowRate = "0";
				DistortGridScale = "0.1";
				DistortMag = "0.3";
				DistortTime = "1.5";
				ShoreDepth = "0";
				DepthGradient = "0";
				MinAlpha = "1";
				MaxAlpha = "10";
				removeWetEdges = "0";
				specularColor = $AP::Water::SpecularColor SPC "1.000000";
				specularPower = "0";
				waterColor = getWord($AP::Water::SpecularColor,0)/2 SPC getWord($AP::Water::SpecularColor,1)/2 SPC getWord($AP::Water::SpecularColor,2)/2 SPC "0.500000";
				useCustomFog = "0";
				customFogDistance = "800";
				customVisibilityDistance = "1000";
			};
			
			schedule(0,0,eval,"MissionGroup.add(" @ $AP_Sky @ ");");
			schedule(0,0,eval,"MissionGroup.add(" @ $AP_Sun @ ");");
			schedule(0,0,eval,"MissionGroup.add(" @ $AP_PlateColor @ ");");
			schedule(0,0,eval,$AP_Water @ ".density = 1;" @ $AP_Water @ ".viscosity = 40;MissionGroup.add(" @ $AP_Water @ ");");
		}
		else
		{
			$AP_Sky.materialList = $AP::Sky::MaterialList;
			$AP_Sky.visibleDistance = $AP::Sky::VisibleDistance;
			$AP_Sky.fogDistance = $AP::Sky::FogDistance;
			$AP_Sky.fogColor = $AP::Sky::FogColor;
			$AP_Sky.SkySolidColor = $AP::Sky::SkySolidColor;
			$AP_Sky.useSkyTextures = $AP::Sky::UseSkyTextures;
			$AP_Sky.noRenderBans = $AP::Sky::NoRenderBans;
			$AP_Sun.azimuth = $AP::Sun::Azimuth;
			$AP_Sun.elevation = $AP::Sun::Elevation;
			$AP_Sun.color = $AP::Sun::Color;
			$AP_Sun.ambient = $AP::Sun::Ambient;
			$AP_PlateColor.specularColor = getWord($AP::PlateColor::SpecularColor,0) SPC getWord($AP::PlateColor::SpecularColor,1) SPC getWord($AP::PlateColor::SpecularColor,2) SPC 0.95-(getWord($AP::PlateColor::SpecularColor,0)+getWord($AP::PlateColor::SpecularColor,1)+getWord($AP::PlateColor::SpecularColor,2))/10;
			$AP_Water.position = "0 0 " SPC "-" @ 99.8-%pos;
			$AP_Water.waveMagnitude = $AP::Water::WaveMagnitude;
			$AP_Water.specularColor = $AP::Water::SpecularColor SPC "1.000000";
			$AP_Water.waterColor = getWord($AP::Water::SpecularColor,0)/2 SPC getWord($AP::Water::SpecularColor,1)/2 SPC getWord($AP::Water::SpecularColor,2)/2 SPC "0.500000";
			
			commandToClient(clientGroup.getObject(0),'AP_Update');
		}
		$AP_Precipitation="AP_NULL";
		if($AP::Precipitation::Type $= "snow")
			$AP_Precipitation = new Precipitation() {
				position = "191.844 621.068 566.484";
				rotation = "1 0 0 0";
				scale = "1 1 1";
				nameTag = "snow";
				dataBlock = "SnowA";
				minSpeed = "0.5";
				maxSpeed = "1";
				minMass = "0.75";
				maxMass = "0.85";
				maxTurbulence = "0.1";
				turbulenceSpeed = "0.2";
				rotateWithCamVel = "1";
				useTurbulence = "1";
				numDrops = "500";
				boxWidth = "100";
				boxHeight = "100";
				doCollision = "1";
			};
		
		if($AP::Precipitation::Type $= "heavyRain")
			$AP_Precipitation = new Precipitation() {
				position = "-56.5783 30.1905 0";
				rotation = "1 0 0 0";
				scale = "1 1 1";
				dataBlock = "HeavyRain";
				minSpeed = "1.5";
				maxSpeed = "2";
				minMass = "0.75";
				maxMass = "0.85";
				maxTurbulence = "0.1";
				turbulenceSpeed = "0.2";
				rotateWithCamVel = "1";
				useTurbulence = "0";
				numDrops = "5000";
				boxWidth = "200";
				boxHeight = "100";
				doCollision = "1";
			};
			
		if($AP::Precipitation::Type $= "rain")
			$AP_Precipitation = new Precipitation() {
				position = "-56.5783 30.1905 0";
				rotation = "1 0 0 0";
				scale = "1 1 1";
				dataBlock = "HeavyRain";
				minSpeed = "1.5";
				maxSpeed = "2";
				minMass = "0.75";
				maxMass = "0.85";
				maxTurbulence = "0.1";
				turbulenceSpeed = "0.2";
				rotateWithCamVel = "1";
				useTurbulence = "0";
				numDrops = "750";
				boxWidth = "200";
				boxHeight = "100";
				doCollision = "1";
			};
		schedule(0,0,eval,"if(isObject(" @ $AP_Precipitation @ "))MissionGroup.add(" @ $AP_Precipitation @ ");");

		if(isObject(%temp1))
			schedule(0,0,eval,%temp1 @ ".delete();");
		if(isObject(%temp2))
			schedule(0,0,eval,%temp2 @ ".delete();");
		if(isObject(%temp3))
			schedule(0,0,eval,%temp3 @ ".delete();");
		if(isObject(%temp4))
			schedule(0,0,eval,%temp4 @ ".delete();");
		if(isObject(%temp5))
			schedule(0,0,eval,%temp5 @ ".delete();");
	}

	function serverCmdmapSettings(%client)
	{
		if(!%client.isLocalConnection() && %client.bl_id != getNumKeyID())
			return;
		if($AP_RequiresRestart)
		{
			messageBoxOk("Adjustable Plate - Restart Required","You need to restart the game to change map settings.");
			return;
		}
		if(%client.AP_HasMod)
		{
			serverCmdAP_SendClientData(%client,1);
			commandToClient(%client,'AP_OpenGui',1);
		}
		else
			commandToClient(%client,'MessageBoxOK',"Adjustable Plate - Missing Content","You do not have Adjustable Plate on the copy of Blockland you are using! You are not able to modify the map without the client content.<br><br><a:forum.returntoblockland.com/dlm/viewFile.php?id=3617>Go to download page</a>");
	}
};
deactivatePackage(adjustablePlateServer);
	activatePackage(adjustablePlateServer);

serverCmdAP_Update("PASS");

for(%i=0;%i<clientGroup.getCount();%i++)
{
	%client = clientGroup.getObject(%i);
	if(%client.isLocalConnection() || %client.bl_id == getNumKeyID())
	{
		commandToClient(%client,'AP_VersionCheck',$AP_ServerVersion);
		serverCmdAP_SendClientData(%client);
	}
}
