///////////////////////////////////
//
//   Add-On: Adjustable Plate
//
//   ---------------------------
//
//   Author: General
//   BL ID: 4878
//
//   ---------------------------
//
//   File: client.cs
//
//   File version: 5
//   Last updated on: 05/08/2012
//                    DD/MM/YYYY
//
///////////////////////////////////



if(getSimTime())
{
	messageBoxOk("Adjustable Plate - Restart Required","You need to restart the game to change map settings.");
	$AP_RequiresRestart = 1;
}

exec("./Gui/AP_Main.gui");
exec("./Gui/AP_Color_Selector.gui");
exec("./Gui/AP_Sky_Texture_Selector.gui");
exec("./Gui/AP_Measurement_Selector.gui");
exec("./Gui/AP_Notification.gui");
exec("./Gui/AP_Save_Manager.gui");

AP_Sky_Texture_Button.text = "";
AP_Sky_Texture_Button_2.text = "";
AP_Sky_Texture_Button_3.text = "";
AP_Sky_Texture_Button_4.text = "";
AP_Sky_Texture_Button_5.text = "";
AP_Sky_Texture_Button_6.text = "";
AP_Sky_Texture_Button_7.text = "";
AP_Sky_Texture_Button_8.text = "";
AP_Sky_Texture_Button_9.text = "";

AP_PrecipitationType.add("NONE",0);
AP_PrecipitationType.add("Snow",1);
AP_PrecipitationType.add("Rain",2);
AP_PrecipitationType.add("Heavy Rain",3);

AP_SaveList.addRow($AP_NumSaves++,"Default");
%file = findFirstFile("config/client/AdjustablePlate/saves/*.cs");
if(%file !$= "")
{
	%a = strReplace(%file,"config/client/AdjustablePlate/saves/","");
	%text = strReplace(%a,".cs","");
	if(%text !$= "Default")
		AP_SaveList.addRow($AP_NumSaves++,%text);
	while(%file !$= "")
	{
		%file = findNextFile("config/client/AdjustablePlate/saves/*.cs");
		if(%file !$= "")
		{
			%a = strReplace(%file,"config/client/AdjustablePlate/saves/","");
			%text = strReplace(%a,".cs","");
			if(%text !$= "Default")
				AP_SaveList.addRow($AP_NumSaves++,%text);
		}
	}
}
AP_SaveList.sort(0,true);

$remapDivision[$remapCount] = "Adjustable Plate";
$remapName[$remapCount] = "Open Settings Window";
$remapCmd[$remapCount] = "AP_BindCommand";
$remapCount++;

function AP_BindCommand()
{
	commandToServer('mapSettings');
}

$AP_ClientVersion = 5;

package adjustablePlateClient
{
	function clientCmdAP_VersionCheck(%sv)
	{
		$AP_VersionError = "";
		commandToServer('AP_ClientHasMod');
		if($AP_ClientVersion < %sv)
			$AP_VersionError = "The version of Adjustable Plate that you are using (V" @ $AP_ClientVersion @ ") is outdated to the version the server is running on (V" @ %sv @ "). You have been prevented from modifying the map\'s settings due to the chance of some functions being incompatible.<br><br><a:forum.returntoblockland.com/dlm/viewFile.php?id=3617>Go to update page</a>";
		if($AP_ClientVersion > %sv)
			$AP_VersionError = "The version of Adjustable Plate that the server is running on (V" @ %sv @ ") is outdated to the version that you are using (V" @ $AP_ClientVersion @ "). You have been prevented from modifying the map\'s settings due to the chance of some functions being incompatible.";
	}

	function AP_SendServerData()
	{		
		if($AP_VersionError !$= "")
			return;

		commandToServer('AP_ReceiveData',1,$AP_Sky_VisibleDistance);
		commandToServer('AP_ReceiveData',2,$AP_Sky_FogDistance);
		commandToServer('AP_ReceiveData',3,$AP_Sky_FogColor);
		if($AP_Sky_UseSkyColor && $AP_Sky_MaterialList $= "Add-Ons/Map_Slate_Storm_Revised/storm.dml")
			commandToServer('AP_ReceiveData',4,"base/data/skies/Sky_Default/resource.dml",$AP_Sky_MaterialList);
		else
			commandToServer('AP_ReceiveData',4,$AP_Sky_MaterialList,$AP_Sky_MaterialList);
		commandToServer('AP_ReceiveData',5,$AP_Sky_SkySolidColor);
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Slate_Storm_Revised/storm.dml")
			commandToServer('AP_ReceiveData',6,0,$AP_Sky_UseSkyTextures);
		else
			commandToServer('AP_ReceiveData',6,$AP_Sky_UseSkyTextures,$AP_Sky_UseSkyTextures);
		commandToServer('AP_ReceiveData',7,$AP_Sky_NoRenderBans);
		commandToServer('AP_ReceiveData',8,$AP_Sun_Azimuth);
		commandToServer('AP_ReceiveData',9,$AP_Sun_Elevation);
		commandToServer('AP_ReceiveData',10,$AP_Sun_Color);
		commandToServer('AP_ReceiveData',11,$AP_Sun_Ambient);
		commandToServer('AP_ReceiveData',12,$AP_PlateColor_SpecularColor);
		commandToServer('AP_ReceiveData',13,$AP_Precipitation_Type);
		commandToServer('AP_ReceiveData',14,$AP_Water_Position);
		commandToServer('AP_ReceiveData',15,$AP_Water_WaveMagnitude);
		commandToServer('AP_ReceiveData',16,$AP_Water_SpecularColor);
		commandToServer('AP_ReceiveData',17,$AP_Water_Enabled);
	}
	
	function clientCmdAP_ReceiveData(%num,%data,%do)
	{
		if($AP_VersionError !$= "")
			return;
			
		if(%do)
			if($AP_OPN)
				return;
			
		if(%num==1)
			$AP_Sky_VisibleDistance = %data;
		if(%num==2)
			$AP_Sky_FogDistance = %data;
		if(%num==3)
			$AP_Sky_FogColor = %data;
		if(%num==4)
			$AP_Sky_MaterialList = %data;
		if(%num==5)
			$AP_Sky_SkySolidColor = %data;
		if(%num==6)
			$AP_Sky_UseSkyTextures = %data;
		if(%num==7)
			$AP_Sky_NoRenderBans = %data;
		if(%num==8)
			$AP_Sun_Azimuth = %data;
		if(%num==9)
			$AP_Sun_Elevation = %data;
		if(%num==10)
			$AP_Sun_Color = %data;
		if(%num==11)
			$AP_Sun_Ambient = %data;
		if(%num==12)
			$AP_PlateColor_SpecularColor = %data;
		if(%num==13)
			$AP_Precipitation_Type = %data;
		if(%num==14)
			$AP_Water_Position = %data;
		if(%num==15)
			$AP_Water_WaveMagnitude = %data;
		if(%num==16)
			$AP_Water_SpecularColor = %data;
		if(%num==17)
			$AP_Water_Enabled = %data;
	}
	
	function clientCmdAP_Update()
	{
		inspect($AP_Sky);
		inspectApply();
		inspect($AP_Sun);
		inspectApply();
		inspect($AP_Water);
		inspectApply();
		inspect($AP_PlateColor);
		inspectApply();
		canvas.popDialog(inspectDlg);
	}

	function clientCmdAP_OpenGui(%com)
	{
		if(%com)
			if($AP_OPN)
				return;
	
		if($AP_VersionError !$= "")
		{
			messageBoxOk("Adjustable Plate - Incompatible Version",$AP_VersionError);
			return;
		}

		AP_SkyColor_Preview.color = AP_DecimalToRGB($AP_Sky_SkySolidColor);
		AP_FogColor_Preview.color = AP_DecimalToRGB($AP_Sky_FogColor);
		AP_SunReflectionLight_Preview.color = AP_DecimalToRGB($AP_Sun_Ambient);
		AP_SunDirectLight_Preview.color = AP_DecimalToRGB($AP_Sun_Color);
		AP_PlateColor_Preview.color = AP_DecimalToRGB($AP_PlateColor_SpecularColor);
		AP_WaterColor_Preview.color = AP_DecimalToRGB($AP_Water_SpecularColor SPC "1");

		AP_SkyUse($AP_Sky_UseSkyTextures);
		if($AP_Water_Enabled)AP_WaterBlocker.setVisible(0);else AP_WaterBlocker.setVisible(1);

		if($AP_Sky_MaterialList $= "base/data/skies/Sky_Blue2/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Clear_Preview_n";
		if($AP_Sky_MaterialList $= "base/data/skies/Sky_Default/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Clear_2_Preview_n";
		if($AP_Sky_MaterialList $= "base/data/skies/Sky_Spooky1/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Spooky_Preview_n";
		if($AP_Sky_MaterialList $= "base/data/skies/Sky_Spooky3/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Cold_Preview_n";
		if($AP_Sky_MaterialList $= "base/data/skies/sunset/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Sunset_Preview_n";
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Slate_Storm_Revised/storm.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Cloudy_Preview_n";
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Skylands/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Clear_3_Preview_n";
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Slate_Desert/cloudy02.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Hot_Preview_n";
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Halloween_Slate/resource.dml")
			AP_SkyTexture_Preview.bitmap = "Add-Ons/Map_AdjustablePlate/Images/Sky_Halloween_Preview_n";
			
		if($AP_Sky_NoRenderBans)
			$AP_FogVisible = 0;
		else
			$AP_FogVisible = 1;
			
		if($AP_Precipitation_Type $= "snow")
			AP_PrecipitationType.setText("Snow");
		if($AP_Precipitation_Type $= "rain")
			AP_PrecipitationType.setText("Rain");
		if($AP_Precipitation_Type $= "heavyRain")
			AP_PrecipitationType.setText("Heavy Rain");
		if($AP_Precipitation_Type $= "")
			AP_PrecipitationType.setText("NONE");

		canvas.popDialog("AP_Main");
		canvas.pushDialog("AP_Main");
	}
	
	function AP_Main::onWake()
	{
		$AP_OPN = 1;
	}
	
	function AP_Main::onSleep()
	{
		$AP_OPN = 0;
	}
	
	function AP_OpenColorGui($AP_ColorGuiFor)
	{
		if($AP_ColorGuiFor == 1)
		{
			%R = getWord($AP_Sky_SkySolidColor,0);
			%G = getWord($AP_Sky_SkySolidColor,1);
			%B = getWord($AP_Sky_SkySolidColor,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Sky Color");
		}
		if($AP_ColorGuiFor == 2)
		{
			%R = getWord($AP_Sky_FogColor,0);
			%G = getWord($AP_Sky_FogColor,1);
			%B = getWord($AP_Sky_FogColor,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Fog Color");
		}
		if($AP_ColorGuiFor == 3)
		{
			%R = getWord($AP_Sun_Ambient,0);
			%G = getWord($AP_Sun_Ambient,1);
			%B = getWord($AP_Sun_Ambient,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Reflection Light Color");
		}
		if($AP_ColorGuiFor == 4)
		{
			%R = getWord($AP_Sun_Color,0);
			%G = getWord($AP_Sun_Color,1);
			%B = getWord($AP_Sun_Color,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Direct Light Color");
		}
		if($AP_ColorGuiFor == 5)
		{
			%R = getWord($AP_PlateColor_SpecularColor,0);
			%G = getWord($AP_PlateColor_SpecularColor,1);
			%B = getWord($AP_PlateColor_SpecularColor,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Plate Color");
		}
		if($AP_ColorGuiFor == 6)
		{
			%R = getWord($AP_Water_SpecularColor,0);
			%G = getWord($AP_Water_SpecularColor,1);
			%B = getWord($AP_Water_SpecularColor,2);
			AP_ColorSelectorRed.value = %R;
			AP_ColorSelectorGreen.value = %G;
			AP_ColorSelectorBlue.value = %B;
			AP_ColorSelectorResult.color = AP_DecimalToRGB(%R SPC %G SPC %B SPC "1.000000");
			AP_Color_Selector_Window.setText("Adjustable Plate - Select Water Color");
		}
		canvas.pushDialog("AP_Color_Selector");
	}

	function AP_OpenMeasurementGui($AP_MeasurementGuiFor)
	{
		if($AP_MeasurementGuiFor == 1)
		{
			AP_Measurement.range = "100 2000";
			AP_Measurement.value = $AP_Sky_VisibleDistance;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Visibility Distance");
		}
		if($AP_MeasurementGuiFor == 2)
		{
			AP_Measurement.range = "0 2000";
			AP_Measurement.value = $AP_Sky_FogDistance;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Fog Distance");
		}
		if($AP_MeasurementGuiFor == 3)
		{
			AP_Measurement.range = "0 360";
			AP_Measurement.value = $AP_Sun_Azimuth;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Sun Rotation");
		}
		if($AP_MeasurementGuiFor == 4)
		{
			AP_Measurement.range = "0 90";
			AP_Measurement.value = $AP_Sun_Elevation;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Sun Elevation");
		}
		if($AP_MeasurementGuiFor == 5)
		{
			AP_Measurement.range = "0 100";
			AP_Measurement.value = $AP_Water_Position;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Water Depth");
		}
		if($AP_MeasurementGuiFor == 6)
		{
			AP_Measurement.range = "0 5";
			AP_Measurement.value = $AP_Water_WaveMagnitude;
			AP_Measurement_Selector_Window.setText("Adjustable Plate - Select Wave Magnitude");
		}
		canvas.pushDialog("AP_Measurement_Selector");
	}

	function AP_ProcessColorGui()
	{
		if($AP_ColorGuiFor == 1)
			$AP_Sky_SkySolidColor = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
		if($AP_ColorGuiFor == 2)
			$AP_Sky_FogColor = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
		if($AP_ColorGuiFor == 3)
			$AP_Sun_Ambient = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
		if($AP_ColorGuiFor == 4)
			$AP_Sun_Color = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
		if($AP_ColorGuiFor == 5)
			$AP_PlateColor_SpecularColor = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
		if($AP_ColorGuiFor == 6)
			$AP_Water_SpecularColor = AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000";
	}

	function AP_ProcessMeasurementGui()
	{
		if($AP_MeasurementGuiFor == 1)
			$AP_Sky_VisibleDistance = AP_Measurement.value;
		if($AP_MeasurementGuiFor == 2)
			$AP_Sky_FogDistance = AP_Measurement.value;
		if($AP_MeasurementGuiFor == 3)
			$AP_Sun_Azimuth = AP_Measurement.value;
		if($AP_MeasurementGuiFor == 4)
			$AP_Sun_Elevation = AP_Measurement.value;
		if($AP_MeasurementGuiFor == 5)
			$AP_Water_Position = AP_Measurement.value;
		if($AP_MeasurementGuiFor == 6)
			$AP_Water_WaveMagnitude = AP_Measurement.value;
	}
	
	function AP_ProcessTextureGui(%matList)
	{
		$AP_Sky_MaterialList = %matList;
		canvas.popDialog("AP_Sky_Texture_Selector");
		clientCmdAP_OpenGui();
		if($AP_Sky_MaterialList $= "Add-Ons/Map_Slate_Storm_Revised/storm.dml" && !$Pref::AP::IgnoreNotification)
			canvas.pushDialog(AP_Notification);
	}
	
	function AP_SaveManagerGuiLoad()
	{
		%ID = AP_SaveList.getSelectedID();
		if(%ID == -1)
		{
			AP_SaveManagerGuiError2();
			return;
		}
		MessageBoxYesNo("Adjustable Plate - Confirm Load", "Are you sure you want to load " @ AP_SaveList.getRowTextById(%ID) @ "?","AP_Load(\"" @ AP_SaveList.getRowTextById(%ID) @ "\");");
	}
	
	function AP_SaveManagerGuiDelete()
	{
		%ID = AP_SaveList.getSelectedID();
		if(%ID == -1)
		{
			AP_SaveManagerGuiError2();
			return;
		}
		if(AP_SaveList.getRowTextById(%ID) $= "Default")
		{
			messageBoxOK("Adjustable Plate - Notification","You cannot delete the default save.");
			return;
		}
		MessageBoxYesNo("Adjustable Plate - Confirm Delete", "Are you sure you want to permanently delete " @ AP_SaveList.getRowTextById(%ID) @ "?","fileDelete(\"config/client/AdjustablePlate/saves/" @ AP_SaveList.getRowTextById(%ID) @ ".cs\"); AP_SaveList.removeRowByID(" @ %ID @ ");");
	}
	
	function AP_SaveManagerGuiSave(%text)
	{
		if(striPos(%text,"\\") !$= -1 || striPos(%text,"/") !$= -1 || striPos(%text,":") !$= -1 || striPos(%text,"*") !$= -1 || striPos(%text,"?") !$= -1 || striPos(%text,"\"") !$= -1 || striPos(%text,"<") !$= -1 || striPos(%text,">") !$= -1 || striPos(%text,"|") !$= -1 || strReplace(%text," ","") $= "")
		{
			AP_SaveManagerGuiError();
			return;
		}
		if(%text $= "Default")
		{
			messageBoxOK("Adjustable Plate - Notification","You cannot replace the default save.");
			return;
		}
		if(!isFile("config/client/AdjustablePlate/saves/" @ %text @ ".cs"))
		{
			AP_Save(%text);
			AP_SaveList.addRow($AP_NumSaves++,%text);
			AP_SaveList.sort(0,true);
		}
		else
			MessageBoxYesNo("Adjustable Plate - Confirm Replace", "Are you sure you want to replace " @ %text @ "?","AP_Save(\"" @ %text @ "\");");
	}
	
	function AP_Save(%text)
	{
		if(isFile("config/client/AdjustablePlate/saves/" @ %text @ ".cs"))
			fileDelete("config/client/AdjustablePlate/saves/" @ %text @ ".cs");
		%file = new FileObject();
		%file.openForWrite("config/client/AdjustablePlate/saves/" @ %text @ ".cs");
		%file.writeLine("$AP_Sky_VisibleDistance = \"" @ $AP_Sky_VisibleDistance @ "\";");
		%file.writeLine("$AP_Sky_FogDistance = \"" @ $AP_Sky_FogDistance @ "\";");
		%file.writeLine("$AP_Sky_FogColor = \"" @ $AP_Sky_FogColor @ "\";");
		%file.writeLine("$AP_Sky_MaterialList = \"" @ $AP_Sky_MaterialList @ "\";");
		%file.writeLine("$AP_Sky_SkySolidColor = \"" @ $AP_Sky_SkySolidColor @ "\";");
		%file.writeLine("$AP_Sky_UseSkyTextures = \"" @ $AP_Sky_UseSkyTextures @ "\";");
		%file.writeLine("$AP_Sky_NoRenderBans = \"" @ $AP_Sky_NoRenderBans @ "\";");
		%file.writeLine("$AP_Sun_Azimuth = \"" @ $AP_Sun_Azimuth @ "\";");
		%file.writeLine("$AP_Sun_Elevation = \"" @ $AP_Sun_Elevation @ "\";");
		%file.writeLine("$AP_Sun_Color = \"" @ $AP_Sun_Color @ "\";");
		%file.writeLine("$AP_Sun_Ambient = \"" @ $AP_Sun_Ambient @ "\";");
		%file.writeLine("$AP_PlateColor_SpecularColor = \"" @ $AP_PlateColor_SpecularColor @ "\";");
		%file.writeLine("$AP_Precipitation_Type = \"" @ $AP_Precipitation_Type @ "\";");
		%file.writeLine("$AP_Water_Position = \"" @ $AP_Water_Position @ "\";");
		%file.writeLine("$AP_Water_WaveMagnitude = \"" @ $AP_Water_WaveMagnitude @ "\";");
		%file.writeLine("$AP_Water_SpecularColor = \"" @ $AP_Water_SpecularColor @ "\";");
		%file.writeLine("$AP_Water_Enabled = \"" @ $AP_Water_Enabled @ "\";");
		%file.close();
		AP_AddSave.setText("");
	}
	
	function AP_Load(%text)
	{
		if(%text $= "Default")
		{
			$AP_Sky_VisibleDistance = "600";
			$AP_Sky_FogDistance = "500";
			$AP_Sky_FogColor = "1 1 1 1";
			$AP_Sky_MaterialList = "base/data/skies/Sky_Blue2/resource.dml";
			$AP_Sky_SkySolidColor = "1 1 1 1";
			$AP_Sky_UseSkyTextures = "1";
			$AP_Sky_NoRenderBans = "0";
			$AP_Sun_Azimuth = "250";
			$AP_Sun_Elevation = "35";
			$AP_Sun_Color = "0.7 0.7 0.7 1";
			$AP_Sun_Ambient = "0.4 0.4 0.3 1";
			$AP_PlateColor_SpecularColor = "0.05 0.47 0.16 1";
			$AP_Precipitation_Type = "";
			$AP_Water_Position = "8.8";
			$AP_Water_WaveMagnitude = "0";
			$AP_Water_SpecularColor = "0 0.4 0.4";
			$AP_Water_Enabled = "0";
		}
		else
		{
			$AP_Water_Position = "NULL";
			exec("config/client/AdjustablePlate/saves/" @ %text @ ".cs");
			if($AP_Water_Position $= "NULL")
			{
				$AP_Water_Position = "8.8";
				$AP_Water_WaveMagnitude = "0";
				$AP_Water_SpecularColor = "0 0.4 0.4";
				$AP_Water_Enabled = "0";
			}
		}
		clientCmdAP_OpenGui();
		canvas.popDialog(AP_Save_Manager);
		canvas.pushDialog(AP_Save_Manager);
	}
	
	function AP_SaveManagerGuiError()
	{
		if(!$AP_SaveError)
		{
			$AP_SaveError = 1;
			AP_SaveError.setVisible(1);
			schedule(250,0,eval,"AP_SaveError.setVisible(0);");
			schedule(500,0,eval,"AP_SaveError.setVisible(1);");
			schedule(750,0,eval,"AP_SaveError.setVisible(0);");
			schedule(1000,0,eval,"$AP_SaveError = 0;");
		}
	}
	
	function AP_SaveManagerGuiError2()
	{
		if(!$AP_SaveError2)
		{
			$AP_SaveError2 = 1;
			AP_SaveError2.setVisible(1);
			schedule(250,0,eval,"AP_SaveError2.setVisible(0);");
			schedule(500,0,eval,"AP_SaveError2.setVisible(1);");
			schedule(750,0,eval,"AP_SaveError2.setVisible(0);");
			schedule(1000,0,eval,"$AP_SaveError2 = 0;");
		}
	}
	
	function AP_ColorSelector::Update()
	{
		AP_ColorSelectorResult.color = AP_DecimalToRGB(AP_ColorSelectorRed.value SPC AP_ColorSelectorGreen.value SPC AP_ColorSelectorBlue.value SPC "1.000000");
	}

	function AP_SkyUse(%type)
	{
		AP_SkyColorBlocker.setVisible(0);
		AP_SkyTextureBlocker.setVisible(0);
		if(%type)
		{
			$AP_Sky_UseSkyColor = 0;
			$AP_Sky_UseSkyTextures = 1;
			if($AP_Sky_MaterialList !$= "Add-Ons/Map_Slate_Storm_Revised/storm.dml")
			{
				AP_SkyColorBlocker.setVisible(1);
			}
		}
		else
		{
			$AP_Sky_UseSkyTextures = 0;
			$AP_Sky_UseSkyColor = 1;
			AP_SkyTextureBlocker.setVisible(1);
		}
	}
	
	function AP_PrecipitationUse(%type)
	{
		if(!%type)
			$AP_Precipitation_Type = "";
		if(%type == 1)
			$AP_Precipitation_Type = "snow";
		if(%type == 2)
			$AP_Precipitation_Type = "rain";
		if(%type == 3)
			$AP_Precipitation_Type = "heavyRain";
	}

	function AP_DecimalToRGB(%RGBA)
	{
		%R = getWord(%RGBA,0);
		%G = getWord(%RGBA,1);
		%B = getWord(%RGBA,2);
		%A = getWord(%RGBA,3);
		return mFloatLength(%R*255, 0) SPC mFloatLength(%G*255, 0) SPC mFloatLength(%B*255, 0) SPC mFloatLength(%A*255, 0);
	}
};
deactivatePackage(adjustablePlateClient);
	activatePackage(adjustablePlateClient);